<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.6"/>
<title>TIML: timl.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIML
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.6 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_4f218e5c1c68a8760266841df915118e.html">src</a></li><li class="navelem"><a class="el" href="dir_e5def28db4ba0142cedf1af2d851f321.html">common</a></li><li class="navelem"><a class="el" href="dir_c5b36bb030c577d6bbefab4a3e5235f0.html">api</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#define-members">Macros</a>  </div>
  <div class="headertitle">
<div class="title">timl.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>timl public APIs  
<a href="#details">More...</a></p>
<div class="textblock"><code>#include &quot;<a class="el" href="timlUtil_8h_source.html">timlUtil.h</a>&quot;</code><br/>
<code>#include &quot;<a class="el" href="timlCNN_8h_source.html">timlCNN.h</a>&quot;</code><br/>
</div>
<p><a href="timl_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr><td colspan="2"><div class="groupHeader"></div></td></tr>
<tr class="memitem:ga71b91e772f1e63528e53a6284ba7b879"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structtimlCNNInputParams.html">timlCNNInputParams</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga71b91e772f1e63528e53a6284ba7b879">timlCNNInputParamsDefault</a> ()</td></tr>
<tr class="memdesc:ga71b91e772f1e63528e53a6284ba7b879"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the default parameters for the input layer.  <a href="group__cnn.html#ga71b91e772f1e63528e53a6284ba7b879">More...</a><br/></td></tr>
<tr class="separator:ga71b91e772f1e63528e53a6284ba7b879"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga33ddb7145ae4e19ea52e12576f4871aa"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structtimlCNNConvParams.html">timlCNNConvParams</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga33ddb7145ae4e19ea52e12576f4871aa">timlCNNConvParamsDefault</a> ()</td></tr>
<tr class="memdesc:ga33ddb7145ae4e19ea52e12576f4871aa"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the default parameters for the convolutional layer.  <a href="group__cnn.html#ga33ddb7145ae4e19ea52e12576f4871aa">More...</a><br/></td></tr>
<tr class="separator:ga33ddb7145ae4e19ea52e12576f4871aa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad5c8fd10f11ccaa8142a665fc8ee93b8"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structtimlCNNLinearParams.html">timlCNNLinearParams</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gad5c8fd10f11ccaa8142a665fc8ee93b8">timlCNNLinearParamsDefault</a> ()</td></tr>
<tr class="memdesc:gad5c8fd10f11ccaa8142a665fc8ee93b8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the default parameters for the linear layer.  <a href="group__cnn.html#gad5c8fd10f11ccaa8142a665fc8ee93b8">More...</a><br/></td></tr>
<tr class="separator:gad5c8fd10f11ccaa8142a665fc8ee93b8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gacd163e268b3ccc9805bcca59689a36f5"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structtimlCNNPoolingParams.html">timlCNNPoolingParams</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gacd163e268b3ccc9805bcca59689a36f5">timlCNNPoolingParamsDefault</a> ()</td></tr>
<tr class="memdesc:gacd163e268b3ccc9805bcca59689a36f5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the default parameters for the pooling layer.  <a href="group__cnn.html#gacd163e268b3ccc9805bcca59689a36f5">More...</a><br/></td></tr>
<tr class="separator:gacd163e268b3ccc9805bcca59689a36f5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga24aaf5f0c47a32c8223073f22c88c184"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structtimlCNNNonlinearParams.html">timlCNNNonlinearParams</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga24aaf5f0c47a32c8223073f22c88c184">timlCNNNonlinearParamsDefault</a> ()</td></tr>
<tr class="memdesc:ga24aaf5f0c47a32c8223073f22c88c184"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the default parameters for the nonlinear layer.  <a href="group__cnn.html#ga24aaf5f0c47a32c8223073f22c88c184">More...</a><br/></td></tr>
<tr class="separator:ga24aaf5f0c47a32c8223073f22c88c184"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga03ee34f7d893af02536bcbf2d071f721"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structtimlCNNNormParams.html">timlCNNNormParams</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga03ee34f7d893af02536bcbf2d071f721">timlCNNNormParamsDefault</a> ()</td></tr>
<tr class="memdesc:ga03ee34f7d893af02536bcbf2d071f721"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the default parameters for the norm layer.  <a href="group__cnn.html#ga03ee34f7d893af02536bcbf2d071f721">More...</a><br/></td></tr>
<tr class="separator:ga03ee34f7d893af02536bcbf2d071f721"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaaf7a5b272ae2ba5d0453f214afaab747"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structtimlCNNTrainingParams.html">timlCNNTrainingParams</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gaaf7a5b272ae2ba5d0453f214afaab747">timlCNNTrainingParamsDefault</a> ()</td></tr>
<tr class="memdesc:gaaf7a5b272ae2ba5d0453f214afaab747"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the default training parameters.  <a href="group__cnn.html#gaaf7a5b272ae2ba5d0453f214afaab747">More...</a><br/></td></tr>
<tr class="separator:gaaf7a5b272ae2ba5d0453f214afaab747"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf75b4687f4b493b8a85bc7fcc37bdf18"><td class="memItemLeft" align="right" valign="top"><a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gaf75b4687f4b493b8a85bc7fcc37bdf18">timlCNNCreateConvNeuralNetwork</a> (<a class="el" href="structtimlCNNTrainingParams.html">timlCNNTrainingParams</a> params, int deviceId)</td></tr>
<tr class="memdesc:gaf75b4687f4b493b8a85bc7fcc37bdf18"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a cnn structure.  <a href="group__cnn.html#gaf75b4687f4b493b8a85bc7fcc37bdf18">More...</a><br/></td></tr>
<tr class="separator:gaf75b4687f4b493b8a85bc7fcc37bdf18"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga253033ab06b21f2bf28301bc1e53c419"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga253033ab06b21f2bf28301bc1e53c419">timlCNNAddInputLayer</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, int featureMapRow, int featureMapCol, int featureMapChannel, <a class="el" href="structtimlCNNInputParams.html">timlCNNInputParams</a> params)</td></tr>
<tr class="memdesc:ga253033ab06b21f2bf28301bc1e53c419"><td class="mdescLeft">&#160;</td><td class="mdescRight">Add input layer.  <a href="group__cnn.html#ga253033ab06b21f2bf28301bc1e53c419">More...</a><br/></td></tr>
<tr class="separator:ga253033ab06b21f2bf28301bc1e53c419"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gab5dcc5ac470e15bea85f0a5570eec37d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gab5dcc5ac470e15bea85f0a5570eec37d">timlCNNAddPoolingLayer</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, int scaleRow, int scaleCol, int strideX, int strideY, timlCNNPoolingType type, <a class="el" href="structtimlCNNPoolingParams.html">timlCNNPoolingParams</a> params)</td></tr>
<tr class="memdesc:gab5dcc5ac470e15bea85f0a5570eec37d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Add pooling layer.  <a href="group__cnn.html#gab5dcc5ac470e15bea85f0a5570eec37d">More...</a><br/></td></tr>
<tr class="separator:gab5dcc5ac470e15bea85f0a5570eec37d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7627fe7a5294d7c8cac75d974b78a27a"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga7627fe7a5294d7c8cac75d974b78a27a">timlCNNAddNormLayer</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <a class="el" href="structtimlCNNNormParams.html">timlCNNNormParams</a> params)</td></tr>
<tr class="memdesc:ga7627fe7a5294d7c8cac75d974b78a27a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Add normalization layer.  <a href="group__cnn.html#ga7627fe7a5294d7c8cac75d974b78a27a">More...</a><br/></td></tr>
<tr class="separator:ga7627fe7a5294d7c8cac75d974b78a27a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga772bc4b21c2f800ee8ac5248a732f116"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga772bc4b21c2f800ee8ac5248a732f116">timlCNNAddConvLayer</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, int kernelRow, int kernelCol, int strideX, int strideY, int featureMapChannel, <a class="el" href="structtimlCNNConvParams.html">timlCNNConvParams</a> params)</td></tr>
<tr class="memdesc:ga772bc4b21c2f800ee8ac5248a732f116"><td class="mdescLeft">&#160;</td><td class="mdescRight">Add conv layer.  <a href="group__cnn.html#ga772bc4b21c2f800ee8ac5248a732f116">More...</a><br/></td></tr>
<tr class="separator:ga772bc4b21c2f800ee8ac5248a732f116"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaddfd98d23613318bdc368eac98fddf0b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gaddfd98d23613318bdc368eac98fddf0b">timlCNNAddNonlinearLayer</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, timlUtilActivationType type)</td></tr>
<tr class="memdesc:gaddfd98d23613318bdc368eac98fddf0b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Add nonlinear layer.  <a href="group__cnn.html#gaddfd98d23613318bdc368eac98fddf0b">More...</a><br/></td></tr>
<tr class="separator:gaddfd98d23613318bdc368eac98fddf0b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga0219ba397301c5fb3eedfb64e62e33bc"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga0219ba397301c5fb3eedfb64e62e33bc">timlCNNAddLinearLayer</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, int dim, <a class="el" href="structtimlCNNLinearParams.html">timlCNNLinearParams</a> params)</td></tr>
<tr class="memdesc:ga0219ba397301c5fb3eedfb64e62e33bc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Add linear layer.  <a href="group__cnn.html#ga0219ba397301c5fb3eedfb64e62e33bc">More...</a><br/></td></tr>
<tr class="separator:ga0219ba397301c5fb3eedfb64e62e33bc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gae988ef172bde701db59b1cfc33dd50ab"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gae988ef172bde701db59b1cfc33dd50ab">timlCNNAddDropoutLayer</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, float prob)</td></tr>
<tr class="memdesc:gae988ef172bde701db59b1cfc33dd50ab"><td class="mdescLeft">&#160;</td><td class="mdescRight">Add dropout layer.  <a href="group__cnn.html#gae988ef172bde701db59b1cfc33dd50ab">More...</a><br/></td></tr>
<tr class="separator:gae988ef172bde701db59b1cfc33dd50ab"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga666fa0a68b725aa1e35dba659ba7c5f9"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga666fa0a68b725aa1e35dba659ba7c5f9">timlCNNInitialize</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn)</td></tr>
<tr class="memdesc:ga666fa0a68b725aa1e35dba659ba7c5f9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate the memory required by the cnn.  <a href="group__cnn.html#ga666fa0a68b725aa1e35dba659ba7c5f9">More...</a><br/></td></tr>
<tr class="separator:ga666fa0a68b725aa1e35dba659ba7c5f9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga21bc0c855cb658f51fe5d6911acddb54"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga21bc0c855cb658f51fe5d6911acddb54">timlCNNReset</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn)</td></tr>
<tr class="memdesc:ga21bc0c855cb658f51fe5d6911acddb54"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reset the parameters of the CNN.  <a href="group__cnn.html#ga21bc0c855cb658f51fe5d6911acddb54">More...</a><br/></td></tr>
<tr class="separator:ga21bc0c855cb658f51fe5d6911acddb54"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga5af48b599237f48f016ce2060c6053e1"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga5af48b599237f48f016ce2060c6053e1">timlCNNDelete</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn)</td></tr>
<tr class="memdesc:ga5af48b599237f48f016ce2060c6053e1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Free a cnn structure.  <a href="group__cnn.html#ga5af48b599237f48f016ce2060c6053e1">More...</a><br/></td></tr>
<tr class="separator:ga5af48b599237f48f016ce2060c6053e1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga9198f6379fad0e9e45dd8f64cc030ec3"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga9198f6379fad0e9e45dd8f64cc030ec3">timlCNNSupervisedTrainingWithLabelBatchMode</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, float *data, int *label, int dim, int num)</td></tr>
<tr class="memdesc:ga9198f6379fad0e9e45dd8f64cc030ec3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Supervised training with label.  <a href="group__cnn.html#ga9198f6379fad0e9e45dd8f64cc030ec3">More...</a><br/></td></tr>
<tr class="separator:ga9198f6379fad0e9e45dd8f64cc030ec3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga8b59ecbca36e54cfa1df0766ece686b5"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga8b59ecbca36e54cfa1df0766ece686b5">timlCNNClassifyTopNBatchMode</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, float *data, int dim, int num, int *label, float *percent, int topN)</td></tr>
<tr class="memdesc:ga8b59ecbca36e54cfa1df0766ece686b5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Batch classification.  <a href="group__cnn.html#ga8b59ecbca36e54cfa1df0766ece686b5">More...</a><br/></td></tr>
<tr class="separator:ga8b59ecbca36e54cfa1df0766ece686b5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gafda5077b0d39c278469278b37f845aed"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gafda5077b0d39c278469278b37f845aed">timlCNNClassifyTop1SingleMode</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, float *data, int dim)</td></tr>
<tr class="memdesc:gafda5077b0d39c278469278b37f845aed"><td class="mdescLeft">&#160;</td><td class="mdescRight">Classify the data.  <a href="group__cnn.html#gafda5077b0d39c278469278b37f845aed">More...</a><br/></td></tr>
<tr class="separator:gafda5077b0d39c278469278b37f845aed"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga04d9a7e3725ce777402e1e5c4d5d4ce0"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga04d9a7e3725ce777402e1e5c4d5d4ce0">timlCNNSetMode</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, timlUtilPhase phase)</td></tr>
<tr class="memdesc:ga04d9a7e3725ce777402e1e5c4d5d4ce0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the phase (train/test) of the cnn.  <a href="group__cnn.html#ga04d9a7e3725ce777402e1e5c4d5d4ce0">More...</a><br/></td></tr>
<tr class="separator:ga04d9a7e3725ce777402e1e5c4d5d4ce0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga409c28e6bb3633f1de65647b790aa320"><td class="memItemLeft" align="right" valign="top"><a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga409c28e6bb3633f1de65647b790aa320">timlCNNClone</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, int deviceId)</td></tr>
<tr class="memdesc:ga409c28e6bb3633f1de65647b790aa320"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clone a cnn.  <a href="group__cnn.html#ga409c28e6bb3633f1de65647b790aa320">More...</a><br/></td></tr>
<tr class="separator:ga409c28e6bb3633f1de65647b790aa320"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga52826c14f9f1913947f5ca6937b5afd5"><td class="memItemLeft" align="right" valign="top"><a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga52826c14f9f1913947f5ca6937b5afd5">timlCNNShareParams</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, int deviceId)</td></tr>
<tr class="memdesc:ga52826c14f9f1913947f5ca6937b5afd5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a new CNN that shares the parameters with the input CNN.  <a href="group__cnn.html#ga52826c14f9f1913947f5ca6937b5afd5">More...</a><br/></td></tr>
<tr class="separator:ga52826c14f9f1913947f5ca6937b5afd5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga2e8a7e765f885a236e40dfaed59913c6"><td class="memItemLeft" align="right" valign="top">long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga2e8a7e765f885a236e40dfaed59913c6">timlCNNMemory</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn)</td></tr>
<tr class="memdesc:ga2e8a7e765f885a236e40dfaed59913c6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the memory in bytes required by the cnn.  <a href="group__cnn.html#ga2e8a7e765f885a236e40dfaed59913c6">More...</a><br/></td></tr>
<tr class="separator:ga2e8a7e765f885a236e40dfaed59913c6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga72df82405eb43be8bb75373aaf8ec101"><td class="memItemLeft" align="right" valign="top">long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga72df82405eb43be8bb75373aaf8ec101">timlCNNGetParamsNum</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn)</td></tr>
<tr class="memdesc:ga72df82405eb43be8bb75373aaf8ec101"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the number of parameters of the cnn.  <a href="group__cnn.html#ga72df82405eb43be8bb75373aaf8ec101">More...</a><br/></td></tr>
<tr class="separator:ga72df82405eb43be8bb75373aaf8ec101"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad7f3f988c763fe5a80826439c9fb08bd"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gad7f3f988c763fe5a80826439c9fb08bd">timlCNNWriteToFile</a> (const char *fileName, <a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <a class="el" href="group__util.html#ga8e44b2a87636024736da04ae5a53c1c9">timlUtilParamsLevel</a> paramsLevel, const char *name, const char *floatFormat, const char *intFormat)</td></tr>
<tr class="memdesc:gad7f3f988c763fe5a80826439c9fb08bd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the cnn to file(s)  <a href="group__cnn.html#gad7f3f988c763fe5a80826439c9fb08bd">More...</a><br/></td></tr>
<tr class="separator:gad7f3f988c763fe5a80826439c9fb08bd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gabab7c3c18a2fa4a3a9985da42662682c"><td class="memItemLeft" align="right" valign="top"><a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gabab7c3c18a2fa4a3a9985da42662682c">timlCNNReadFromFile</a> (const char *fileName, int deviceId)</td></tr>
<tr class="memdesc:gabab7c3c18a2fa4a3a9985da42662682c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read CNN from file(s)  <a href="group__cnn.html#gabab7c3c18a2fa4a3a9985da42662682c">More...</a><br/></td></tr>
<tr class="separator:gabab7c3c18a2fa4a3a9985da42662682c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga123557b8025497fe266d58d80ee9983b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga123557b8025497fe266d58d80ee9983b">timlCNNPrint</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn)</td></tr>
<tr class="memdesc:ga123557b8025497fe266d58d80ee9983b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Print out the information of the cnn.  <a href="group__cnn.html#ga123557b8025497fe266d58d80ee9983b">More...</a><br/></td></tr>
<tr class="separator:ga123557b8025497fe266d58d80ee9983b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga13c723ecb589f7da7e01a9cd9591061d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga13c723ecb589f7da7e01a9cd9591061d">timlCNNProfile</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, float *data, int dim, int num, int *label, int iter)</td></tr>
<tr class="memdesc:ga13c723ecb589f7da7e01a9cd9591061d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Profile the CNN with both timing and memory allocation.  <a href="group__cnn.html#ga13c723ecb589f7da7e01a9cd9591061d">More...</a><br/></td></tr>
<tr class="separator:ga13c723ecb589f7da7e01a9cd9591061d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga78addba765ea7dd8bf958d19d42be931"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga78addba765ea7dd8bf958d19d42be931">timlCNNResize</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, int row, int col, int channel)</td></tr>
<tr class="memdesc:ga78addba765ea7dd8bf958d19d42be931"><td class="mdescLeft">&#160;</td><td class="mdescRight">Resize the feature map sizes to accommodate new input feature map dimensions.  <a href="group__cnn.html#ga78addba765ea7dd8bf958d19d42be931">More...</a><br/></td></tr>
<tr class="separator:ga78addba765ea7dd8bf958d19d42be931"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf65f8d45c892f70eeee34b47791bdcb5"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gaf65f8d45c892f70eeee34b47791bdcb5">timlCNNGetLayerNum</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn)</td></tr>
<tr class="memdesc:gaf65f8d45c892f70eeee34b47791bdcb5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the number of layers of the cnn.  <a href="group__cnn.html#gaf65f8d45c892f70eeee34b47791bdcb5">More...</a><br/></td></tr>
<tr class="separator:gaf65f8d45c892f70eeee34b47791bdcb5"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>timl public APIs </p>
</div></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Mar 20 2015 11:26:08 for TIML by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.6
</small></address>
</body>
</html>
